<?php

//////////////////////////////////////////////////////////////
//===========================================================
// addserver_theme.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 1.0
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Alons
// Date:       8th Mar 2010
// Time:       23:00 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

function getSortHeader($header_name, $sort_column, $sort_column_by, $column ,$size = 90){

	global $theme, $globals;
	
	$str = '<div class="d-inline-flex align-items-center" style="width:'.$size.'px;">
				<div class="mr-2">
					<span class="" >'.$header_name.'</span>
				</div>
				<span class="sorter">
					<a class="text-dark" href="'.$globals['index'].'act=tasks&sortcolumn='.$column.'&sortby=asc"><i class="fas fa-sort-up"></i></a><br>
					<a class="text-dark" href="'.$globals['index'].'act=tasks&sortcolumn='.$column.'&sortby=desc"><i class="fas fa-sort-down"></i></a>
				</span>
			</div>';
		
	return $str;
}

function tasks_theme(){

global $theme, $globals, $servers, $user, $l, $list, $cluster, $error, $done, $servergroups, $migrate_status, $cpu, $progress, $migrate_done, $migrate_run, $mprog, $tasks;

softheader($l['<title>']);

// If we need to find the next sub task for MAIN task
$find_actid = optREQ('find_actid');
$find_action = optREQ('find_action');
$find_vps = optREQ('find_vps');

// All three values are compulsary
if(!empty($find_actid)){

	$token_vals = array();
	$token_vals[':vpsid'] = $find_vps;
	$slaveactid = optREQ('slaveactid');
	$serid = optREQ('serid');
	
	// We need to handle this for slave. To show it properly on slave servers, because on slave server slaveactid will be 0
	if(!empty($globals['slave']) && !empty($slaveactid)){
		$find_actid = $slaveactid;
		$slaveactid = 0;
	}
	
	// If the task s from slave server then we will have to check in slaveactid 
	if(isset($serid) && !empty($slaveactid)){
		
		$serid = (int) $serid;
		$tmp_query = 'slaveactid = :slaveactid AND 
					serid = :serid';
		$token_vals[':slaveactid'] = $slaveactid;
		$token_vals[':serid'] = $serid;
	// Search for specifi actid (like startvps, poweroff etc...)
	}else if(empty($find_action)){
		$tmp_query = "actid = :actid";
		$token_vals[':actid'] = $find_actid;
	// If main process has multiple tasks then those actid will be > current actid (Like addvs, rebuild etc..)
	}else{
		$tmp_query = "actid > :actid AND 
					action = :action";
		$token_vals[':actid'] = $find_actid;
		$token_vals[':action'] = $find_action;
	}
	
	$res = makequery('SELECT logs FROM tasks WHERE 
				'.$tmp_query.' AND
				vpsid = :vpsid
				LIMIT 0,1', $token_vals);
				
	if(vsql_num_rows($res) < 1){
		return false;
	}
	
	$row = vsql_fetch_assoc($res);
	echo $row['logs'];
	return true;
}

echo '
<div class="bg" >
<div class="row mx-auto my-3">
<div class="col-10">
<h4 class="text-dark"><i class="fas fa-tasks"></i> '.$l['<title>'].'</h4>
</div>
<div class="col-2 text-right">
<span class="search_btn"><a href="javascript:showsearch();" class="text-dark"><i class="fas fa-search"></i></a></span>
</div>
</div>';

error_handle($error);

echo '<script language="javascript" type="text/javascript"><!-- // --><![CDATA[
var prog = 0;
function make_progress(index, progress){
	var steps = 20;
	var start = $("#pbar"+index).text();
	start = (start.slice(0, -1));
	if(isNaN(start)){
		start = 0;
	}
	var step = (progress - start)/steps;
	if(step < 0){ step = 0;}
	var increment = function(){
		var val = $("#pbar"+index).text();
		val = Number(val.slice(0, - 1));
		prog = parseInt(val + Math.round(step));
		//alert("progr"+prog);
		if(prog > progress){ prog = progress;}
		if(prog < parseInt("100")){
			$("#pbar"+index).text(prog + "%");
			$("#progressbar"+index).width(prog + "%");
		}else{
			$("#progressbar"+index).width(100 + "%");
		}
		if (prog < progress){setTimeout(increment, 500);}
	};
	increment();
};

function make_table(id, data){
		
	try{
		data = JSON.parse(data);
	}catch(e){
		return;
	}
	
	var html = "<div>";
	$.each(data, function(i, item){
		if(i != "progress"){
			html += "<b>"+i+"&nbsp;:&nbsp;&nbsp;</b>"+item+"<br>";
		}
	});
	html += "</div>";
	$(id).attr("tooltip", html);
	$(id).html(html);
};

function get_taskprogress(act){
	var search = $("#task_search").find("input[type=text], select").serialize();
	$.ajax({type: "GET",
		url: "'.$globals['index'].'&act=tasks&page='.optREQ('page').'&reslen='.optREQ('reslen').'&sortcolumn='.optREQ('sortcolumn').'&sortby='.optREQ('sortby').'&"+search+"&api=json",
		dataType : "json",
		success:function(data){
			var tasks = data.tasks;
			$.each(tasks, function(index, value){
				if(tasks[index]["progress"] == 100){
					$("#status"+index).removeAttr("tooltip");
					$("#status"+index).unbind();
					$("#status"+index).text("'.$l['completed'].'");
					$("#pbar"+index).text("100% '.$l['completed'].' !");
					$("#progressbar"+index).hide();
					$("#progressbar"+index).parent().css("border", "0px");
					$("#progressbar"+index).parent().removeClass("progress");
				}else if(tasks[index]["status"] == -1){
					$("#status"+index).html(tasks[index]["status_txt"]);
					if(!empty(tasks[index]["status_txt"])){
						$("#status"+index).attr("tooltip",tasks[index]["status_txt"]);
					}
					$("#pbar"+index).text("'.$l['task_notcomplete'].'");
					$("#progressbar"+index).hide();
					$("#progressbar"+index).parent().css("border", "0px");
					$("#progressbar"+index).parent().removeClass("progress");
				}else{
					// We have to create the table in case of migrate and clone
					if(tasks[index]["action"] == "migrate2" || tasks[index]["action"] == "clone2" || tasks[index]["action"] == "multimigrateprog" || tasks[index]["action"] == "multicloneprog"){
						make_table("#status"+index, tasks[index]["status_txt"]);
						
					}else{
						$("#status"+index).text(tasks[index]["status_txt"]);
						if(!empty(tasks[index]["status_txt"])){
							$("#status"+index).attr("tooltip",tasks[index]["status_txt"]);
						}
						$("#progressbar"+index).hide();
						$("#progressbar"+index).parent().css("border", "0px");
						$("#progressbar"+index).parent().removeClass("progress");
					}
					
					if(isNaN(tasks[index]["progress"])){
						$("#pbar"+index).text(tasks[index]["progress"]);
						$("#progressbar"+index).hide();
						$(".progress_"+index).hide();
					}else{
						$("#progressbar"+index).parent().addClass("progress");
						make_progress(index, Number(tasks[index]["progress"]));
						$("#progressbar"+index).show();
					}
				}
				$("#started"+index).html(tasks[index]["started"]);
				$("#updated"+index).html(tasks[index]["updated"]);
				$("#ended"+index).html(tasks[index]["ended"]);
			});
			show_tooltip();
		}
	});
	setTimeout(function(){get_taskprogress(act);}, 10000);
};

$(document).ready(function(){
	var act = new Array();';
	if(count($tasks) > 0){
		foreach($tasks as $k => $v){
			echo 'act.push('.$v['actid'].');';
		}
		echo 'get_taskprogress(act);';
	}
	echo '
	
});


// ]]></script><script>
$(document).ready(function(){
  $("#search_task").on("keyup", function(e) {
	var value = $(this).val().toLowerCase();

	$("#myTable tr").filter(function() {
		if(value.length >= 2 ){
			$(this).toggle($(this).find("#actid").text().toLowerCase().indexOf(value) > -1 || $(this).find("#vpsid").text().toLowerCase().indexOf(value) > -1 || $(this).find("#email").text().toLowerCase().indexOf(value) > -1 || $(this).find("#action").text().toLowerCase().indexOf(value) > -1)
		}else{
			$(this).show();
		}
		//
		if($(this).find("#actid").text().toLowerCase().indexOf(value) > -1  && value.length > 0){
			var txt = $(this).find("#actid").text().toLowerCase().replace(value, \'<span class="highlight">\' + value +  \'</span>\');
			$(this).find("#actid").html(txt);
		}else{
			var txt1 = $(this).find("#actid").text().replace(\'<span class="highlight">\', \'\');
			txt1 = $(this).find("#actid").text().toLowerCase().replace(\'</span>\',\'\');
			$(this).find("#actid").html(txt1);
		}
		//
		if($(this).find("#vpsid").text().toLowerCase().indexOf(value) > -1  && value.length > 0){
			var txt = $(this).find("#vpsid").text().toLowerCase().replace(value, \'<span class="highlight">\' + value +  \'</span>\');
			$(this).find("#vpsid").html(txt);
		}else{
			var txt1 = $(this).find("#vpsid").text().replace(\'<span class="highlight">\', \'\');
			txt1 = $(this).find("#vpsid").text().toLowerCase().replace(\'</span>\',\'\');
			$(this).find("#vpsid").html(txt1);
		}

		if($(this).find("#action").text().toLowerCase().indexOf(value) > -1  && value.length > 0){
			var og = $(this).text().substr($(this).text().toLowerCase().indexOf(value), value.length);
			var txt = $(this).find("#action").text().replace(og, \'<span class="highlight">\' + og +  \'</span>\');
			$(this).find("#action").html(txt);
		}else{
			var txt1 = $(this).find("#action").text().replace(\'<span class="highlight">\', \'\');
			txt1 = $(this).find("#action").text().replace(\'</span>\',\'\');
			$(this).find("#action").html(txt1);
		}
		//
		if($(this).find("#email").text().toLowerCase().indexOf(value) > -1  && value.length > 0){
			var txt = $(this).find("#email").text().toLowerCase().replace(value, \'<span class="highlight">\' + value +  \'</span>\');
			$(this).find("#email").html(txt);
		}else{
			var txt1 = $(this).find("#email").text().replace(\'<span class="highlight">\', \'\');
			txt1 = $(this).find("#email").text().toLowerCase().replace(\'</span>\',\'\');
			$(this).find("#email").html(txt1);
		}
	});
  });
});
</script>';

// Take this for display notice when no process available
echo '<div id="showsearch" style="display:'.(optREQ('search') || (!empty($tasks) && !empty($globals['showsearch'])) ? "" : "none").';">
<form accept-charset="'.$globals['charset'].'"  class="form-horizontal" name="tasks" method="GET" action="" id="task_search">
<input type="hidden" name="act" value="tasks">
<input type="hidden" name="page" value="1">
<input type="hidden" name="reslen" value="50">
<div class="form-group_head">
	<div class="row mx-auto w-100">
		<div class="col-sm-4">
			<label>'.$l['actid'].'</label>
			<input type="text" class="form-control" name="actid" id="actid" size="15" value="'.REQval('actid','').'" />
		</div>
		<div class="col-sm-4">
			<label>'.$l['vpsid'].'</label>
			<input type="text" class="form-control" name="vpsid" id="vpsid" size="15" value="'.REQval('vpsid','').'" />
		</div>
		<div class="col-sm-4">
			<label>'.$l['user'].'</label>
			<input type="text" class="form-control" name="username" id="username" size="15" value="'.REQval('username','').'" />
		</div>
	</div>
	<div class="row mx-auto w-100">
		<div class="col-sm-4 server-select-lg">
			<label>'.$l['action'].'</label>
			<select class="custom-select virt-select" name="action" id="action">
				<option value="0">---</option>
				<option value="addvs" '.REQselect('action', 'addvs').'>'.$l['addvs'].'</option>
				<option value="addvs_restore" '.REQselect('action', 'addvs_restore').'>'.$l['addvs_restore'].'</option>
				<option value="rebuildvs" '.REQselect('action', 'rebuildvs').'>'.$l['rebuildvs'].'</option>
				<option value="vpsbackups" '.REQselect('action', 'vpsbackups').'>'.$l['vpsbackups'].'</option>
				<option value="restorevps" '.REQselect('action', 'restorevps').'>'.$l['restorevps'].'</option>
				<option value="migrate2" '.REQselect('action', 'migrate2').'>'.$l['migrateprog'].'</option>
				<option value="multimigrateprog" '.REQselect('action', 'multimigrateprog').'>'.$l['multimigrateprog'].'</option>
				<option value="clone2" '.REQselect('action', 'clone2').'>'.$l['cloneprog'].'</option>
				<option value="multicloneprog" '.REQselect('action', 'multicloneprog').'>'.$l['multicloneprog'].'</option>
				<option value="deletevs" '.REQselect('action', 'deletevs').'>'.$l['deletevs'].'</option>
				<option value="createtemplate" '.REQselect('action', 'createtemplate').'>'.$l['createtemplate'].'</option>
				<option value="fstab_handle" '.REQselect('action', 'fstab_handle').'>'.$l['fstab_handle'].'</option>
				<option value="editxcpvs" '.REQselect('action', 'editxcpvs').'>'.$l['editxcpvs'].'</option>
				<option value="resizevps" '.REQselect('action', 'resizevps').'>'.$l['resizevps'].'</option>
				<option value="multivirt" '.REQselect('action', 'multivirt').'>'.$l['multivirt'].'</option>
				<option value="getos" '.REQselect('action', 'getos').'>'.$l['getos'].'</option>
				<option value="addiso" '.REQselect('action', 'addiso').'>'.$l['addiso'].'</option>
				<option value="change_dnsnameserver" '.REQselect('action', 'change_dnsnameserver').'>'.$l['change_dnsnameserver'].'</option>
				<option value="changepassword" '.REQselect('action', 'changepassword').'>'.$l['changepassword'].'</option>
				<option value="install_cp" '.REQselect('action', 'install_cp').'>'.$l['install_cp'].'</option>
				<option value="hostname" '.REQselect('action', 'hostname').'>'.$l['hostname'].'</option>
				<option value="install_recipe" '.REQselect('action', 'install_recipe').'>'.$l['install_recipe'].'</option>
				<option value="bandwidth_unsuspend" '.REQselect('action', 'bandwidth_unsuspend').'>'.$l['bandwidth_unsuspend'].'</option>
				<option value="suspend_callback" '.REQselect('action', 'suspend_callback').'>'.$l['suspend_callback'].'</option>
				<option value="unsuspend_callback" '.REQselect('action', 'unsuspend_callback').'>'.$l['unsuspend_callback'].'</option>
				<option value="editvps_callback" '.REQselect('action', 'editvps_callback').'>'.$l['editvps_callback'].'</option>
				<option value="terminate_callback" '.REQselect('action', 'terminate_callback').'>'.$l['terminate_callback'].'</option>
				<option value="get_crt" '.REQselect('action', 'get_crt').'>'.$l['get_crt'].'</option>
				<option value="renew_crt" '.REQselect('action', 'renew_crt').'>'.$l['renew_crt'].'</option>
				<option value="cron_crt" '.REQselect('action', 'cron_crt').'>'.$l['cron_crt'].'</option>
				<option value="haproxy_cron" '.REQselect('action', 'haproxy_cron').'>'.$l['haproxy_cron'].'</option>
				<option value="vpsbackups_plan" '.REQselect('action', 'vpsbackups_plan').'>'.$l['vpsbackups_plan'].'</option>
				<option value="restorevps_plan" '.REQselect('action', 'restorevps_plan').'>'.$l['restorevps_plan'].'</option>
				<option value="addsshkeys" '.REQselect('action', 'addsshkeys').'>'.$l['addsshkeys'].'</option>
				<option value="installxentools" '.REQselect('action', 'installxentools').'>'.$l['installxentools'].'</option>
				<option value="dbbackups" '.REQselect('action', 'dbbackups').'>'.$l['dbbackups'].'</option>
				<option value="install_script" '.REQselect('action', 'install_script').'>'.$l['install_script'].'</option>
			</select>
		</div>
		<div class="col-sm-4">
			<label>'.$l['status'].'</label>
			<select class="custom-select" name="status" id="status">
				<option value="">---</option>
				<option value="1" '.REQselect('status', '1').'>'.$l['inprogress'].'</option>
				<option value="2" '.REQselect('status', '2').'>'.$l['completed'].'</option>
				<option value="3" '.REQselect('status', '3').'>'.$l['notupdated'].'</option>
				<option value="-1" '.REQselect('status', '-1').'>'.$l['error'].'</option>			
			</select>
		</div>
		<div class="col-sm-4">
			<label>'.$l['server'].'</label>
			<select class="custom-select virt-select" name="server">';
				echo "<option value='-1' ".REQselect('server', '-1').">---</option>";
				foreach ($servers as $serid => $server_name) {
					echo "<option value='$serid' ".REQselect('server', $serid).">".$server_name['server_name']."</option>";
				}
	echo	'</select>
		</div>
	</div>
	<div class="row mx-auto w-100 my-2">
		<div class="col-sm-12 text-center"><input type="submit" name="search" value="'.$l['submit'].'" class="go_btn mt-2"/></div>
	</div>
</div>


</form>

</div><input id="search_task" type="text" placeholder="'.$l['quick_search'].'" class="w-100 form-control mt-3">';

// Take this for display notice when no process available
if(empty($tasks)){
	echo '<div class="notice" id="complete"><b>'.$l['note'].' : </b> &nbsp; '.$l['no_tasks'].'</div>';
}else{
	echo'<div class="row mx-auto w-100 mt-3">
		<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
			page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
		echo'
		</div>
	</div>';

echo '<div class="mx-auto scrollbar-virt task_table">
<table class="table table-hover tablesorter tasks_table">
<tr>
	<th class="min_width">'.getSortHeader($l['actid'], $sort_column, $sort_column_by, 'actid','50').'</td>
	<th class="min_width">'.getSortHeader($l['vpsid'], $sort_column, $sort_column_by, 'vpsid','55').'</th>
	<th>'.$l['user'].'</th>
	<th>'.getSortHeader($l['server'].'('.$l['id'].')', $sort_column, $sort_column_by, 'server').'</th>
	<th class="min_width">'.getSortHeader($l['started'], $sort_column, $sort_column_by, 'started', '70').'</th>
	<th class="min_width">'.getSortHeader($l['updated'], $sort_column, $sort_column_by, 'updated', '70').'</th>
	<th class="min_width">'.getSortHeader($l['ended'], $sort_column, $sort_column_by, 'ended', '70').'</th>
	<th class="min_width">'.$l['action'].'</th>
	<th class="min_width">'.getSortHeader($l['status'], $sort_column, $sort_column_by, 'status', 70).'</th>
	<th class="min_width">'.$l['progress'].'</th>
	<th class="min_width">'.$l['logs'].'</th>
</tr><tbody id="myTable">';

$i = 1;
foreach($tasks as $k => $v){
	echo '<tr>
		<td align="center" id="actid">'.$v['actid'].'</td>
		<td id="vpsid">'.$v['vpsid'].'</td>
		<td id="email">'.$v['email'].'</td>
		<td>'.(!empty($v['server_name']) ? $v['server_name'].' ('.$v['serid'].')' : $l['unslaved']).'</td>
		<td><span id="started'.$v['actid'].'">'.$v['started'].'</span></td>
		<td><span id="updated'.$v['actid'].'">'.$v['updated'].'</span></td>
		<td><span id="ended'.$v['actid'].'">'.$v['ended'].'</span></td>
		<td id="action">'.$l[$v['action']].'</td>
		<td id="status'.$v['actid'].'" class="wrap"></td>
		<td><div class="progress-cont" id="progress-cont'.$v['actid'].'">
			<center><div id="pbar'.$v['actid'].'">'.$v['progress'].'%</center>
			<div class="progress progress_'.$v['actid'].'">
				<div class="progress-bar bg-primary progress-bar-striped progress-bar-animated" style="width:0px;" id="progressbar'.$v['actid'].'">
				</div>
			</div>
		</td>
		<td align="center">
			<a href="javascript:void(0);" onclick="return loadlogs('.$v['actid'].');" class="btn px-2 py-1">'.$l['show_logs'].'</a>
		</td>
	</tr>';
	$i++;
	}
	echo '</tbody></table></div>';
}
echo'<div class="row mx-auto w-100 mt-3">
		<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
			page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
		echo'
		</div>
	</div>
<br></div>';

softfooter();
}

?>